import {expect, test} from '@jest/globals';
import * as prettier from "prettier"
import * as erubyParse from "../index"

test("format multiple erb elements", async () => {
  const code =
`<DIV>
  test
  <% test1 %>
    <%= test2 %>
<%=
  test3
  test4
%>
</DIV>
`
  const result = await prettier.format(code, { parser: "eruby-parse", plugins: [erubyParse] })
  expect(result).toBe(
`<div>
  test
  <% test1 %>
  <%= test2 %>
  <%=
    test3
    test4
  %>
</div>
`
  )
})

test("format block", async () => {
  const code =
`  <%= form_with test do %>
test
                  <%= link_to test do %> link <% end %>
      <% end %>
`
  const result = await prettier.format(code, { parser: "eruby-parse", plugins: [erubyParse] })
  expect(result).toBe(
`<%= form_with test do %>
  test
  <%= link_to test do %>
    link
  <% end %>
<% end %>
`
  )
})
