"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const globals_1 = require("@jest/globals");
const prettier = __importStar(require("prettier"));
const erubyParse = __importStar(require("../index"));
(0, globals_1.test)("format multiple erb elements", () => __awaiter(void 0, void 0, void 0, function* () {
    const code = `<DIV>
  test
  <% test1 %>
    <%= test2 %>
<%=
  test3
  test4
%>
</DIV>
`;
    const result = yield prettier.format(code, { parser: "eruby-parse", plugins: [erubyParse] });
    (0, globals_1.expect)(result).toBe(`<div>
  test
  <% test1 %>
  <%= test2 %>
  <%=
    test3
    test4
  %>
</div>
`);
}));
(0, globals_1.test)("format block", () => __awaiter(void 0, void 0, void 0, function* () {
    const code = `  <%= form_with test do %>
test
                  <%= link_to test do %> link <% end %>
      <% end %>
`;
    const result = yield prettier.format(code, { parser: "eruby-parse", plugins: [erubyParse] });
    (0, globals_1.expect)(result).toBe(`<%= form_with test do %>
  test
  <%= link_to test do %>
    link
  <% end %>
<% end %>
`);
}));
