"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _ErbElement_instances, _ErbElement_matchResult, _ErbElement_originalContentRegExp_get, _ErbElement_originalPositionIndex_get, _ErbElement_originalContentLength_get, _ErbElement_erbTag_get, _ErbElement_indentedContent, _ErbPrettierPlugin_erbElements;
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultOptions = exports.options = exports.printers = exports.parsers = exports.erbPrettierPlugin = exports.languages = void 0;
const prettier = __importStar(require("prettier"));
const assert_1 = __importDefault(require("assert"));
class ErbElement {
    constructor(matchResult) {
        _ErbElement_instances.add(this);
        this.tagId = -1;
        _ErbElement_matchResult.set(this, void 0);
        __classPrivateFieldSet(this, _ErbElement_matchResult, matchResult, "f");
    }
    replaceErbElementToTag(text) {
        return text.substring(0, __classPrivateFieldGet(this, _ErbElement_instances, "a", _ErbElement_originalPositionIndex_get)) +
            __classPrivateFieldGet(this, _ErbElement_instances, "a", _ErbElement_erbTag_get) +
            text.substring(__classPrivateFieldGet(this, _ErbElement_instances, "a", _ErbElement_originalPositionIndex_get) + __classPrivateFieldGet(this, _ErbElement_instances, "a", _ErbElement_originalContentLength_get));
    }
    replaceErbTagToElement(text) {
        const markMatchResult = text.match(__classPrivateFieldGet(this, _ErbElement_instances, "a", _ErbElement_originalContentRegExp_get));
        (0, assert_1.default)(markMatchResult);
        return text.replace(__classPrivateFieldGet(this, _ErbElement_instances, "a", _ErbElement_originalContentRegExp_get), __classPrivateFieldGet(this, _ErbElement_instances, "m", _ErbElement_indentedContent).call(this, markMatchResult[1]));
    }
    // duplicate code
    get isOpenTag() { return /\s*do\s*(\|\s*.*\s*\|\s*)?%>/.test(__classPrivateFieldGet(this, _ErbElement_instances, "m", _ErbElement_indentedContent).call(this, '')); }
    get isCloseTag() { return /<%\s*end\s*%>/.test(__classPrivateFieldGet(this, _ErbElement_instances, "m", _ErbElement_indentedContent).call(this, '')); }
}
_ErbElement_matchResult = new WeakMap(), _ErbElement_instances = new WeakSet(), _ErbElement_originalContentRegExp_get = function _ErbElement_originalContentRegExp_get() {
    let erbTagRegExp = this.isOpenTag ? `<${'erb'.repeat(100)}-${this.tagId}\\s*>` :
        this.isCloseTag ? `</${'erb'.repeat(100)}-${this.tagId}\\s*>` : `<erb-${this.tagId}\\s*/>`;
    return new RegExp(`([^\\S\\r\\n]*)(${erbTagRegExp})`);
}, _ErbElement_originalPositionIndex_get = function _ErbElement_originalPositionIndex_get() { return __classPrivateFieldGet(this, _ErbElement_matchResult, "f").index; }, _ErbElement_originalContentLength_get = function _ErbElement_originalContentLength_get() { return __classPrivateFieldGet(this, _ErbElement_matchResult, "f")[0].length; }, _ErbElement_erbTag_get = function _ErbElement_erbTag_get() {
    // Open and Close tag must break line
    switch (true) {
        case this.isOpenTag: return `<${'erb'.repeat(100)}-${this.tagId}>\n`;
        case this.isCloseTag: return `\n</${'erb'.repeat(100)}-${this.tagId}>`;
        default: return `<erb-${this.tagId} />`;
    }
}, _ErbElement_indentedContent = function _ErbElement_indentedContent(spaces) {
    const HeadWhitespaceRemovedContent = __classPrivateFieldGet(this, _ErbElement_matchResult, "f")[0]
        .split("\n")
        .map((line) => line.replace(new RegExp(`^${__classPrivateFieldGet(this, _ErbElement_matchResult, "f")[1]}`), ""))
        .join("\n");
    return HeadWhitespaceRemovedContent.split("\n").map((line) => `${spaces}${line}`).join("\n");
};
class ErbPrettierPlugin {
    constructor() {
        _ErbPrettierPlugin_erbElements.set(this, void 0);
        __classPrivateFieldSet(this, _ErbPrettierPlugin_erbElements, [], "f");
        this.astFormat = "eruby-ast";
    }
    parse(text, options) {
        return __awaiter(this, void 0, void 0, function* () {
            __classPrivateFieldSet(this, _ErbPrettierPlugin_erbElements, [], "f");
            // The reason for reverse() is that the index is broken when replacing
            const reverseMatchResults = Array.from(text.matchAll(/([^\S\r\n]*)<%[\s\n]*.*?[\s\n]*%>/gs)).reverse();
            const endTagIds = [];
            reverseMatchResults.forEach((currentMatchResult, i) => {
                const erbElement = new ErbElement(currentMatchResult);
                if (erbElement.isCloseTag) {
                    erbElement.tagId = i;
                    endTagIds.push(erbElement.tagId);
                }
                else if (erbElement.isOpenTag) {
                    const endTagId = endTagIds.pop();
                    (0, assert_1.default)(endTagId !== undefined);
                    erbElement.tagId = endTagId;
                }
                else {
                    erbElement.tagId = i;
                }
                __classPrivateFieldGet(this, _ErbPrettierPlugin_erbElements, "f").push(erbElement);
            });
            const replacedText = __classPrivateFieldGet(this, _ErbPrettierPlugin_erbElements, "f").reduce((acc, erbElement) => erbElement.replaceErbElementToTag(acc), text);
            return yield prettier.format(replacedText, { parser: "html" });
        });
    }
    locStart(node) {
        return 0;
    }
    locEnd(node) {
        return 0;
    }
    print(path, options, print) {
        let result = path.getNode();
        return __classPrivateFieldGet(this, _ErbPrettierPlugin_erbElements, "f").reduce((acc, erbElement) => erbElement.replaceErbTagToElement(acc), result);
    }
}
_ErbPrettierPlugin_erbElements = new WeakMap();
exports.languages = [
    {
        name: "eRuby",
        parsers: ["eruby-parse"],
        extensions: [".html.erb"]
    }
];
exports.erbPrettierPlugin = new ErbPrettierPlugin();
exports.parsers = {
    "eruby-parse": exports.erbPrettierPlugin
};
exports.printers = {
    "eruby-ast": exports.erbPrettierPlugin
};
exports.options = {};
exports.defaultOptions = {};
